;      NSM lab
;======Stereo Cassette Tape Deck TK-190======

;------Constantes------

;Parameters

W8582  .EQU 0A0H        ;address PCF8582 and write mode
R8582  .EQU 0A1H        ;address PCF8582 and read  mode
STACK	.EQU 056H	   ;stack address
ASDLP  .EQU 014H        ;autostop delay for play
ASDLF  .EQU 005H        ;autostop delay for fast modes
RTCHI  .EQU 0F0H        ;RTC timer load value low
RTCLO  .EQU 000H        ;RTC timer load value high
RTCPC  .EQU 0F5H        ;RTC program counter value
RTCPV  .EQU 050H        ;peak ind program counter
APMIN	.EQU 0C8H        ;APLD min level
APMAX	.EQU 0E8H        ;APLD max level
BLTM   .EQU 078H        ;APLD blink delay
TSLEV	.EQU 0FFH        ;TEST min level
TSTOK  .EQU 045H        ;TEST OK TDONE value

;Long Functions Codes

CODST	.EQU 020H	   ;STOP code
CODPL	.EQU 021H	   ;PLAY code
CODPA	.EQU 022H	   ;PAUSE code
CODRW	.EQU 023H	   ;REWIND code
CODFF	.EQU 024H	   ;FAST FORWARD code
CODSR	.EQU 025H	   ;SEARCH REWIND code
CODSF	.EQU 026H	   ;SEARCH FORWARD code
CODAR	.EQU 027H	   ;APLD REWIND code
CODAF	.EQU 028H	   ;APLD FORWARD code
CODTE  .EQU 029H        ;TEST code
CODEJ	.EQU 02AH	   ;EJECT code
CODLO	.EQU 02BH	   ;LOAD code

;Graph Symbols Codes

GRSTP	.EQU 040H	   ;stop symbol
GRPLY  .EQU 020H        ;play symbol
GRPAU	.EQU 033H        ;pause symbol
GRREW	.EQU 011H        ;rewind symbol
GRFFD	.EQU 022H        ;fast forward symbol
GRREC	.EQU 050H	   ;record symbol
GRLOA	.EQU 060H	   ;load symbol
GREJE	.EQU 070H	   ;eject symbol
GRCLE  .EQU 000H	   ;clear

;------Memory Specification------

;Special Functions Registers

ACC  .EQU 0E0H
ACC0 .EQU 0E0H ;bit ACC.0
ACC1 .EQU 0E1H ;bit ACC.1
ACC2 .EQU 0E2H ;bit ACC.2
ACC3 .EQU 0E3H ;bit ACC.3
ACC4 .EQU 0E4H ;bit ACC.4
ACC5 .EQU 0E5H ;bit ACC.5
ACC6 .EQU 0E6H ;bit ACC.6
ACC7 .EQU 0E7H ;bit ACC.7
B    .EQU 0F0H
SP   .EQU 081H ;stack pointer
DPL  .EQU 082H
DPH  .EQU 083H
PSW  .EQU 0D0H ;PSW
RS0  .EQU 0D3H ;bit 3 PSW
RS1  .EQU 0D4H ;bit 4 PSW
EX0  .EQU 0A8H ;bit 0 IE
ET0  .EQU 0A9H ;bit 1 IE
EX1  .EQU 0AAH ;bit 2 IE
ET1  .EQU 0ABH ;bit 3 IE
EA   .EQU 0AFH ;bit 7 IE
PX0  .EQU 0B8H ;bit 0 IP
PT0  .EQU 0B9H ;bit 1 IP
PX1  .EQU 0BAH ;bit 2 IP
PT1  .EQU 0BBH ;bit 3 IP
IT0  .EQU 088H ;bit 0 TCON
IT1  .EQU 08AH ;bit 2 TCON
TR0  .EQU 08CH ;bit 4 TCON
TF0  .EQU 08DH ;bit 5 TCON
TR1  .EQU 08EH ;bit 6 TCON
TF1  .EQU 08FH ;bit 7 TCON
TH0  .EQU 08CH ;timer0 H
TL0  .EQU 08AH ;timer0 L
TH1  .EQU 08DH ;timer1 H
TL1  .EQU 08BH ;timer1 L
TMOD .EQU 089H

;Registers

R00  .EQU 000H ;R0 in bank 0
R01  .EQU 001H ;R1 in bank 0
R02  .EQU 002H ;R2 in bank 0
R03  .EQU 003H ;R3 in bank 0
R04  .EQU 004H ;R4 in bank 0
R05  .EQU 005H ;R5 in bank 0
R06  .EQU 006H ;R6 in bank 0
R07  .EQU 007H ;R7 in bank 0
R37  .EQU 01FH ;R7 in bank 3

;Ports

P1     .EQU 090H ;port 1
SER	.EQU 090H ;bit P1.0
KEY	.EQU 091H ;bit P1.1
DIR	.EQU 092H ;bit P1.2
RES    .EQU 093H ;bit P1.3
COM1   .EQU 094H ;bit P1.4
COM2   .EQU 095H ;bit P1.5
COM3   .EQU 096H ;bit P1.6
EZ     .EQU 097H ;bit P1.7
P2     .EQU 0A0H ;port 2
SDA    .EQU 0B0H ;bit P3.0 (SDA)
SCL    .EQU 0B1H ;bit P3.1 (SCL)
INT0   .EQU 0B2H ;bit P3.2 (INT0)
COM	.EQU 0B4H ;bit P3.4 (T0)
T1     .EQU 0B5H ;bit P3.5 (T1)

;Bit Addressing Memory

MLED1	.EQU 020H ;---leds 1 copy
APM	.EQU 000H ;APLD led, APLD mode flag
LIEC2	.EQU 001H ;IEC2 led
LVIEW	.EQU 002H ;VIEW led
LIEC1	.EQU 003H ;IEC1 led
LLMIN	.EQU 004H ;left minus led
LRTDB	.EQU 005H ;right dB led
LLFDB	.EQU 006H ;left dB led
LRMIN	.EQU 007H ;right minus led
MLED2	.EQU 021H ;---leds 2 copy
LAUTP	.EQU 008H ;AUTO PLAY led
LCONP	.EQU 009H ;CONT. PLAY led
LDOLB	.EQU 00AH ;Dolby symbol led
LAUXT	.EQU 00BH ;AUX symbol T led
LTEST	.EQU 00CH ;TEST led
RTCE	.EQU 00DH ;TIMER led, RTC flag
LMUTE  .EQU 00EH ;MUTE led
CTEN	.EQU 00FH ;COUNTER led, CNT flag
MLED3	.EQU 022H ;---leds 3 copy
LRECD	.EQU 010H ;RECORD led
LDBYC	.EQU 011H ;Dolby C led
LLEFT	.EQU 012H ;symbol L led
LDBYB	.EQU 013H ;Dolby B led
LRIGT	.EQU 014H ;symbol R led
LAUXF	.EQU 015H ;AUX symbol F led
LMPXF	.EQU 016H ;MPX filter led
MEME	.EQU 017H ;MEMORY led, MEM flag
MLED4	.EQU 023H ;---leds 4 copy
LEJEC	.EQU 018H ;EJECT led
LBMIN	.EQU 019H ;BIAS minus led
LNMIN	.EQU 01AH ;NAAC minus led
LSCAL	.EQU 01BH ;Scale leds
MLDWR	.EQU 024H ;---load write register copy
LOADM	.EQU 020H ;load motor on to load
UNLDM	.EQU 021H ;load motor on to unload
EM3	.EQU 022H ;EM3 on
EM1	.EQU 023H ;EM1 on
EM2	.EQU 024H ;EM2 on
LP	.EQU 025H ;load power on
MLDRD	.EQU 025H ;---load read register copy
DOWN	.EQU 028H ;down position
UP	.EQU 029H ;up position
FRONT	.EQU 02AH ;front position
REAR 	.EQU 02BH ;rear position
RPR	.EQU 02CH ;record protect
IEC2	.EQU 02DH ;IEC2 tape
CSTIN	.EQU 02EH ;cassette in
LMDOV	.EQU 02FH ;load motor drive overload
MOPWR	.EQU 026H ;---operation write register copy
MVIN	.EQU 030H ;operation motor moves in
MVOUT	.EQU 031H ;operation motor moves out
REWM	.EQU 032H ;rewind motor on
FFDM	.EQU 033H ;fast forward motor on
WINDM	.EQU 034H ;wind motor on
DRIVEM .EQU 035H ;drive motor on
MOPRD	.EQU 027H ;---operation read register copy
STOPS	.EQU 038H ;stop state
SEARS	.EQU 039H ;search state
MIDS	.EQU 03AH ;mid state
PAUSS	.EQU 03BH ;pause state
WINDS	.EQU 03CH ;wind state
PLAYS	.EQU 03DH ;play state
OMDOV	.EQU 03EH ;operation motor drive overload
FLAGS1	.EQU 028H ;---flags
FAST	.EQU 040H ;fast main loop flag
UNLD	.EQU 041H ;cassette unloaded
CLDD	.EQU 042H ;cassette loaded
ERROR	.EQU 043H ;load error flag
RLS	.EQU 044H ;cassette sensor release flag
ASTEN	.EQU 045H ;autostop enable flag
TAPS	.EQU 046H ;tape stand flag
BLINK	.EQU 047H ;blink bit
FLAGS2	.EQU 029H ;---flags
GMUT	.EQU 048H ;global mute flag
RTCG   .EQU 049H ;RTC go enable
LCR	.EQU 04AH ;right cannel encoder flag
MUC    .EQU 04BH ;mute control bit
EL1	.EQU 02AH ;---MODE1 copy
K0	.EQU 050H ;ADC switcher bit 0
K1	.EQU 051H ;ADC switcher bit 1
K2	.EQU 052H ;ADC switcher bit 2
MUP	.EQU 053H ;mute on play
MUR	.EQU 054H ;mute on rec
EIEC2  .EQU 055H ;IEC 2
EIEC4  .EQU 056H ;IEC 4
RECA	.EQU 057H ;rec amp on
EL2    .EQU 02BH ;---MODE2 copy
EDC    .EQU 058H ;Dolby C
EDB    .EQU 059H ;Dolby B
EDOFF  .EQU 05AH ;Dolby OFF

;Internal Memory

CTL	.EQU 030H ;counter low byte
CTH    .EQU 031H ;counter high byte
RTL    .EQU 032H ;timer low byte
RTH    .EQU 033H ;timer high byte
MEML   .EQU 034H ;memory low byte
MEMH   .EQU 035H ;memory high byte
ALTCL  .EQU 036H ;alt counter low byte
ALTCH  .EQU 037H ;alt counter high byte
ALTML  .EQU 038H ;alt memory low byte
ALTMH  .EQU 039H ;alt memory high byte
CODE   .EQU 03AH ;control code
MISF   .EQU 03BH ;missing function code
NOWF	.EQU 03CH ;now function code
PROF   .EQU 03DH ;processing function code
PART	.EQU 03EH ;function done part
DELVAL .EQU 03FH ;delay time value
ASC	.EQU 040H ;autostop program counter
RTPC	.EQU 041H ;real time program counter
APN	.EQU 042H ;APLD number
CLPBD	.EQU 043H ;clipboard
DISPM	.EQU 044H ;display mode
SCAN   .EQU 045H ;ind scan counter
MA1	.EQU 046H ;ind reg A
MB1	.EQU 047H ;ind reg B
MC1	.EQU 048H ;ind reg C
MD1	.EQU 049H ;ind reg D
ME1	.EQU 04AH ;ind reg E
MF1	.EQU 04BH ;ind reg F
MG1	.EQU 04CH ;ind reg G
MH1	.EQU 04DH ;ind reg H
MPEAL	.EQU 04EH ;max peak level left
MPEAR	.EQU 04FH ;max peak level right
RTCP   .EQU 050H ;peak ind program counter

;External Memory

LOAD	.EQU 000H ;load R/W registers
OPER	.EQU 008H ;operation R/W registers
KD1D	.EQU 010H ;KD1 DATA
KD1C   .EQU 011H ;KD1 CONTROL
KD2D	.EQU 018H ;KD2 DATA
KD2C   .EQU 019H ;KD2 CONTROL
MODE5	.EQU 020H ;controls
MODE6	.EQU 028H ;controls
MODE7	.EQU 030H ;controls
MODE8	.EQU 038H ;controls
NAACI	.EQU 040H ;NAAC 2-digit indicator
BIASI	.EQU 041H ;BIAS 2-digit indicator
PEAKL  .EQU 042H ;peak left 2-digit indicator
PEAKR  .EQU 043H ;peak right 2-digit indicator
LEDS1  .EQU 044H ;LEDS 1
LEDS2  .EQU 045H ;LEDS 2
LEDS3  .EQU 046H ;LEDS 3
LEDS4  .EQU 047H ;LEDS 4
LDI1	.EQU 048H ;led indicator register 1
LDI2	.EQU 050H ;led indicator register 2
DACM   .EQU 058H ;DAC level meter
MODE1	.EQU 060H ;controls
MODE2  .EQU 068H ;controls
MODE3	.EQU 070H ;controls
MODE4	.EQU 078H ;controls

;------Vectors Area------

	.ORG 0000H ;reset vector
	LJMP INIT
	.ORG 0003H ;INT0 vector
	LJMP RC5
	.ORG 000BH ;INT TIMER 0 vector
	LJMP RTC
	.ORG 0013H ;INT1 vector
	LJMP COUNT

;------Interrupts holders------

;External Interrupt 0

RC5:   PUSH PSW
	PUSH DPH
	PUSH DPL
	SETB RS0
	SETB RS1         ;bank 3
	MOV R5,A

	JB KEY,KEYD      ;jump if key pressed
	JNB SER,RCD      ;jump if RC input active
	SJMP NORC5       ;go to return

KEYD:	MOV R0,#KD2C     ;KD control address load
	MOV A,#40H       ;set addr. keyb. memory 00H
	MOVX @R0,A       ;control word write
	MOV R0,#KD2D     ;KD data address load
	MOVX A,@R0       ;read data
	MOV DPTR,#KYTAB  ;table address load
	MOVC A,@A+DPTR   ;recoding
	MOV R3,A         ;new code store

	MOV A,R7
	ANL A,#0C0H      ;save D6,D7-control bits
	ORL A,R3         ;combine command code and D6,D7
	CPL ACC6         ;inverting D6 KY control bit
	MOV R7,A         ;store command data
	SJMP NORC5       ;go to return

RCD:	MOV R6,#1H       ;RC5-code program decoding
	MOV R2,#2H
	MOV R3,#4H
WLOW:  JNB SER,WLOW
	MOV R0,#1AH
	MOV R1,#0ECH
SAMPLE:MOV A,R6
	NOP
	NOP
	NOP
	JB ACC1,THIGH
	JNB SER,TRANS
NOTRAN:DJNZ R1,SAMPLE
NORC5: MOV A,R5
	POP DPL
	POP DPH
	POP PSW
	RETI

THIGH: JNB SER,NOTRAN
TRANS: XRL A,#2H
	MOV R6,A
	MOV A,R1
	ADD A,#4EH
	JC NORC5
	MOV A,R1
	ADD A,#8CH
	MOV A,R6
	JNC T2
	XRL A,#1H
	MOV R6,A
	MOV R1,#0EAH
	JB ACC0,SAMPLE
STDATA:CLR C
	CPL C
	JB ACC1,DAT1
	CLR C
DAT1:  MOV A,@R0
	RLC A
	MOV @R0,A
	MOV R1,#0E9H
	JNC SAMPLE
	INC R0
	MOV A,R0
	CPL A
	MOV R1,#0E9H
	JB ACC2,SAMPLE
WLW:   JNB SER,WLW
	MOV R0,#0FEH
TERM:  JNB SER,NORC5
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	DJNZ R0,TERM

	MOV A,R2         ;system nom. and control bit in R2
	ANL A,#1FH
	CJNE A,#0H,NORC5 ;system number check

	MOV DPTR,#RCTAB  ;table address load
	MOV A,R3	   ;command code load
	MOVC A,@A+DPTR   ;recoding
	MOV R3,A         ;new code store

	MOV A,R2         ;system nom. and control bit in R2
	ANL A,#20H       ;control bit separating
	RL A
	RL A             ;D7-control bit RC
	ORL A,R3         ;combine command code and control bit
	MOV R3,A         ;store

	MOV A,R7
	ANL A,#40H       ;save D6-control bit KY
	ORL A,R3         ;combine command code and D6,D7
	MOV R7,A         ;store command data
	SJMP NORC5       ;go to return

T2:    JB ACC0,NORC5
	SJMP STDATA

KYTAB	.DB 000H,000H,000H,000H,000H,000H,000H,000H
	.DB 02AH,023H,022H,020H,021H,024H,000H,000H
	.DB 000H,000H,019H,000H,016H,017H,002H,004H
	.DB 000H,000H,003H,000H,00AH,018H,00CH,00BH
	.DB 000H,000H,00EH,000H,000H,000H,001H,000H
	.DB 000H,000H,000H,000H,000H,000H,01AH,000H

RCTAB	.DB 026H,007H,008H,009H,013H,020H,022H,023H
	.DB 021H,024H,025H,000H,012H,00CH,006H,00FH
	.DB 011H,010H,000H,000H,000H,000H,000H,000H
	.DB 000H,000H,000H,000H,000H,000H,000H,000H
	.DB 00EH,003H,000H,000H,000H,000H,005H,000H
	.DB 000H,000H,000H,000H,000H,000H,000H,000H
	.DB 000H,000H,000H,000H,000H,000H,000H,000H
	.DB 00BH,000H,000H,004H,000H,000H,000H,014H

;Timer 0 Interrupt

RTC:   CLR TR0          ;timer 0 stop
	MOV TH0,#RTCHI   ;timer 0 load for 4mS
	MOV TL0,#RTCLO   ;timer start
	SETB TR0         ;timer 0 start

	PUSH PSW
	PUSH ACC
	SETB RS0
	CLR RS1          ;bank 1

	MOV A,DISPM      ;display mode check
	JNZ RTC5         ;jump if level ind disable
	MOV R1,#MA1      ;load R1 with base ind reg address

	MOV A,SCAN       ;load scan cycle number
	ANL A,#7H        ;number bits select
	ADD A,R1         ;make ind reg address
	MOV R0,A         ;ind address store
	MOV A,@R0        ;load A from ind reg
	MOV R0,#LDI1     ;led ind address 1 load
	MOVX @R0,A       ;led reg load
	INC SCAN         ;scan cycle inc

	MOV A,SCAN       ;load scan cycle number
	ANL A,#7H        ;number bits select
	ADD A,R1         ;make ind reg address
	MOV R0,A         ;ind address store
	MOV A,@R0        ;load A from ind reg
	MOV R0,#LDI2     ;led ind address 2 load
	MOVX @R0,A       ;led reg load
	INC SCAN         ;scan cycle inc

	DEC RTCP	    ;program counter peak ind dec
	MOV A,RTCP        ;program counter check
	JNZ RTC5          ;peak ind skip if no overload

	PUSH DPH
	PUSH DPL
	MOV RTCP,#RTCPV  ;program counter reload
	MOV DPTR,#LOGTAB ;log table base address load

	MOV A,MPEAL      ;load left max peak level
	MOV MPEAL,#0H    ;left max peak level clear
	MOVC A,@A+DPTR   ;read table
	MOV C,ACC7       ;minus bit load
	MOV LLMIN,C      ;set/clear minus led flag
	CLR ACC7         ;minus bit clear
	LCALL HEX2D      ;recoding
	MOV R0,#PEAKL    ;peak ind reg address load
	MOVX @R0,A       ;peak ind reg load

	MOV A,MPEAR      ;load right max peak level
	MOV MPEAR,#0H    ;right max peak level clear
	MOVC A,@A+DPTR   ;read log table
	MOV C,ACC7       ;minus bit load
	MOV LRMIN,C      ;set/clear minus led flag
	CLR ACC7         ;minus bit clear
	LCALL HEX2D      ;recoding
	MOV R0,#PEAKR    ;peak ind reg address load
	MOVX @R0,A       ;peak ind reg load

	MOV R0,#LEDS1    ;led reg 1 address load
	MOV A,MLED1      ;copy led reg 1 read
	MOVX @R0,A       ;minus leds on/off
	POP DPL
	POP DPH

RTC5:	JNB RTCG,RTC1     ;real timer skip if RTCG=0
	DEC RTPC          ;program counter decrement
	MOV A,RTPC        ;program counter check
	JNZ RTC1          ;skip if 1S interval goes on

	PUSH DPH
	PUSH DPL

	MOV RTPC,#RTCPC  ;1S interval is over, RTPC load with 16
	MOV A,RTL        ;real time low byte inc
	ADD A,#1H
	DA A
	MOV RTL,A
	CJNE A,#60H,RTC2 ;jump if 1M interval goes on
	MOV RTL,#0H      ;if 1M interval is over, load RTL with zero
	MOV A,#1H        ;real time high byte inc
	ADD A,RTH
	DA A
	MOV RTH,A

RTC2:	JNB RTCE,RTC3    ;jump if real time indication disable
	MOV A,APN
	JNZ RTC3         ;jump if APLD display enable

	MOV R3,RTH
	MOV R2,RTL
	LCALL HEX        ;real time value display

RTC3:  POP DPL
	POP DPH

RTC1:	POP ACC
	POP PSW
	RETI

;External Interrupt 1

COUNT: PUSH ACC
	PUSH PSW
	PUSH DPH
	PUSH DPL
	CLR  RS0
	SETB RS1         ;bank 2

	JNB DIR,MINUS    ;jump if reverse tape direction
	MOV ASC,#0H      ;auto stop program counter clear
	MOV A,CTL        ;tape counter 2/10 inc
	ADD A,#1H
	DA A
	MOV CTL,A
	MOV A,CTH
	ADDC A,#0H
	DA A
	MOV CTH,A
	SJMP COU0
MINUS: MOV A,NOWF
	XRL A,#CODPL
	JZ COU4          ;no prog counter clear if play
	MOV ASC,#0H      ;auto stop program counter clear
COU4:	MOV A,CTL        ;tape counter 2/10 dec
	ADD A,#99H
	DA A
	MOV CTL,A
	MOV A,CTH
	ADDC A,#99H
	DA A
	MOV CTH,A

COU0:	MOV A,NOWF       ;now function check
	XRL A,#CODFF     ;FFD code
	JZ COU3          ;jump if FFD
	MOV A,NOWF
	XRL A,#CODRW     ;REW code
	JZ COU3          ;jump if REW

COU1:  JNB CTEN,COU2    ;jump if tape counter indication disable
	MOV A,APN
	JNZ COU2         ;jump if APLD display enable

	MOV R3,CTH
	MOV R2,CTL
	LCALL HEX        ;counter value display

COU2:  SETB RES         ;triggers reset
	CLR RES

	POP DPL
	POP DPH
	POP PSW
	POP ACC
	RETI

COU3:	MOV A,MEML       ;memory value check
	CPL A
	JZ COU1          ;jump if MEML=0FFH
	CPL A
	CJNE A,CTL,COU1  ;compare MEML and CTL
	MOV A,MEMH
	CJNE A,CTH,COU1  ;compare MEMH and CTH
	MOV MISF,CLPBD   ;load MISF with CLPBD
	SJMP COU1

;------Main Program------

INIT:  MOV SP,#STACK    ;stack init
	CLR T1           ;clear bell line
	CLR A
	MOV SCAN,A       ;led ind scan counter init
	MOV MPEAL,A      ;max peak level left clear
	MOV MPEAR,A      ;max peak level right clear

	LCALL WRO0       ;operation register clear
	LCALL WRL0       ;load register clear

	MOV MLED1,A      ;LEDs copy registers clear
	MOV MLED2,A
	MOV MLED3,A
	MOV MLED4,A
	LCALL LEDS       ;clear LEDs registers

	CLR A            ;2-digit indicators clear
	CPL A
	MOV R0,#NAACI
	MOVX @R0,A
	MOV R0,#BIASI
	MOVX @R0,A
	MOV R0,#PEAKL
	MOVX @R0,A
	MOV R0,#PEAKR
	MOVX @R0,A

	CLR EZ           ;off reset

	LCALL KKDIN      ;KD1 and KD2 init

	MOV APN,#0H      ;APLD number clear
	CLR RES          ;clear counter trigger reset
	CLR FAST         ;clear fast main loop flag
	CLR RLS          ;clear release flag

	CLR GMUT         ;clear global mute flag
	CLR RECA
	SETB MUC
	CLR K0           ;clear switcher address
	CLR K1
	CLR K2

	;EEPROM !!!

	MOV CTL,#0H
	MOV CTH,#0H
	MOV RTL,#0H
	MOV RTH,#0H
	MOV MEML,#0FFH
	MOV MEMH,#0FFH
	MOV DISPM,#0H
	CLR RTCE
	CLR MEME
	SETB CTEN
	CLR APM
	SETB EDC
	CLR EDB

	LCALL SETDM      ;set display mode with DISPM
	LCALL CIND       ;counter display
	LCALL LEDS       ;leds on/off
	LCALL ELC        ;el. signals on/off

	MOV CODE,R37     ;set same code conditions
	LCALL NORMO      ;operate normalisation
	LCALL NORML      ;load normalisation
	MOV NOWF,#CODST
	MOV MISF,#CODST
	MOV PROF,#CODST
	MOV CLPBD,#CODST
	MOV DELVAL,#0H

	MOV TH0,#RTCHI   ;timer 0 load
	MOV TL0,#RTCLO
	MOV RTPC,#RTCPC  ;real time program counter load
	MOV RTCP,#RTCPV
	CLR RTCG         ;RTC go disable
	MOV TMOD,#11H    ;timer1 and timer0 init
	SETB EX0         ;enable INT0
	SETB PX0         ;high   INT0 priority
	CLR IT0          ;level  INT0 activating
	SETB EX1         ;enable INT1
	SETB PX1         ;high   INT1 priority
	CLR IT1          ;level  INT1 activating
	CLR PT0          ;low timer0 int priority
	SETB ET0         ;timer 0 int enable
	SETB TR0         ;timer 0 start
	SETB EA          ;interrupts enable

MAIN:  JNB UNLD,M2      ;jump if unload flag clear
	LCALL RDL        ;read sensor
	JB CSTIN,M1      ;jump if no cassette
	JNB RLS,MAIN     ;loop if no release
	LCALL DE100      ;delay 100ms
	LCALL RDL        ;read sensor agane
	JB CSTIN,M1      ;jump if no cassette
	MOV MISF,#CODLO  ;load function code to MISF
	CLR RLS          ;clear release flag
	SJMP M2
M1:	SETB RLS         ;set release flag
M2:	MOV A,R37        ;command code load
	CJNE A,CODE,DIF  ;jump if new command

LONG:	MOV A,MISF       ;missing mode code load
	CJNE A,NOWF,LOFN ;jump if NOWF<>MISF
	LJMP LIND
LOFN:  LJMP LOF

DIF:   MOV CODE,A       ;new press, store code
	ANL A,#3FH       ;control bits clear
	JZ LONG          ;unused code
	JNB ACC5,SF      ;jump if short function

;Long Functions Codes Store in MISF

	CJNE A,MISF,ALI
	SJMP LONG
ALI:	MOV MISF,A
	SJMP LONG

;Short Functions Analysis and Processing

SF:    JB FAST,LONG        ;if FAST=1 then short func. disable
	SETB T1             ;beep
	CLR T1
	MOV R6,A
	CJNE R6,#01H,$+6H   ;counter reset code
	LCALL CTRES
	CJNE R6,#02H,$+6H   ;memory code
	LCALL MEM
	CJNE R6,#03H,$+6H   ;APLD code
	LCALL AP
	CJNE R6,#04H,$+6H   ;save code
	LCALL SAV
	CJNE R6,#05H,$+6H   ;counter code
	LCALL CT
	CJNE R6,#06H,$+6H   ;real time counter code
	LCALL TM
	CJNE R6,#07H,$+6H   ;IEC1 code
	LCALL SIEC1
	CJNE R6,#08H,$+6H   ;IEC2 code
	LCALL SIEC2
	CJNE R6,#09H,$+6H   ;IEC4 code
	LCALL SIEC4
	CJNE R6,#0AH,$+6H   ;NR OFF code
	LCALL NROFF
	CJNE R6,#0BH,$+6H   ;Dolby B code
	LCALL SDB
	CJNE R6,#0CH,$+6H   ;Dolby C code
	LCALL SDC
	CJNE R6,#0DH,$+6H   ;MPX code
	LCALL SMPX
	CJNE R6,#0EH,$+6H   ;MUTE code
	LCALL SMU
	CJNE R6,#0FH,$+6H   ;phones line code
	LCALL SPL
	CJNE R6,#10H,$+6H   ;phones EQ code
	LCALL SPC
	CJNE R6,#11H,$+6H   ;show memory
	LCALL SHM
	CJNE R6,#12H,$+6H   ;alternative counter and memory
	LCALL ALT
	CJNE R6,#13H,$+6H   ;RECORD code
	LCALL REC
	CJNE R6,#14H,$+6H   ;TEST code
	LCALL MTST
	CJNE R6,#15H,$+6H   ;SLEEP code
	LCALL SLEEP
	CJNE R6,#16H,$+6H   ;DISPLAY MODE code
	LCALL DISMD
	CJNE R6,#17H,$+6H   ;REPEAT code
	LCALL REPEAT
	CJNE R6,#18H,$+6H   ;AUTO PLAY code
	LCALL AUTPL
	CJNE R6,#19H,$+6H   ;VIEW code
	LCALL VIEW
	CJNE R6,#1AH,$+6H   ;timer/counter code
	LCALL TMCT
	LJMP LONG

;MISF Analysis and Long Functions Processing

LOF:	MOV R6,MISF         ;long function codes analysis
	CJNE R6,#CODLO,$+6H ;load code
	LCALL LOD
	CJNE R6,#CODEJ,$+6H ;eject code
	LCALL EJT
	JB UNLD,LOFE        ;jump if unload
	CJNE R6,#CODST,$+6H ;stop code
	LCALL STP
	CJNE R6,#CODPL,$+6H ;play code
	LCALL PLY
	CJNE R6,#CODPA,$+6H ;pause code
	LCALL PSE
	CJNE R6,#CODRW,$+6H ;rewind code
	LCALL REW
	CJNE R6,#CODFF,$+6H ;fast forward code
	LCALL FFD
	CJNE R6,#CODSR,$+6H ;search rewind code
	LCALL SCHR
	CJNE R6,#CODSF,$+6H ;search forward code
	LCALL SCHF
	CJNE R6,#CODAR,$+6H ;APLD revind code
	LCALL APLDR
	CJNE R6,#CODAF,$+6H ;APLD forward code
	LCALL APLDF
	CJNE R6,#CODTE,$+6H ;TEST code
	LCALL TEST
LOFE:	JNB FAST,LIND       ;go to LIND if FAST=0
	LJMP MAIN

;Level Indicator Routine

LIND:	MOV A,#0H        ;switcher address load
	ORL A,EL1        ;combine with EL1 bits
	MOV R0,#MODE1    ;MODE1 reg address load
	MOVX @R0,A	   ;left channel VU on
	CLR LCR          ;clear right channel flag for LC
	LCALL ADC        ;convert
	LCALL LC         ;coding
	MOV MA1,R00      ;ind regs refresh
	MOV MB1,R01
	MOV MC1,R02
	MOV MD1,R03

	MOV A,#1H        ;switcher address load
	ORL A,EL1        ;combine with EL1 bits
	MOV R0,#MODE1    ;MODE1 reg address load
	MOVX @R0,A       ;right cannel VU on
	SETB LCR         ;set right channel flag for LC
	LCALL ADC        ;convert
	LCALL LC         ;coding
	MOV ME1,R00      ;ind regs refresh
	MOV MF1,R01
	MOV MG1,R02
	MOV MH1,R03

	MOV A,#2H        ;switcher address load
	ORL A,EL1        ;combine with EL1 bits
	MOV R0,#MODE1    ;MODE1 reg address load
	MOVX @R0,A       ;left channel PEAK
	LCALL ADC        ;convert
	MOV A,MPEAL      ;max peak level left load
	CLR C
	SUBB A,R5        ;compare with R5
	JNC LESLL        ;jump if R5 less
	MOV MPEAL,R5     ;new max value store

LESLL: MOV A,#3H        ;switcher address load
	ORL A,EL1        ;combine with EL1 bits
	MOV R0,#MODE1    ;MODE1 reg address load
	MOVX @R0,A       ;right channel PEAK
	LCALL ADC        ;convert
	MOV A,MPEAR      ;max peak level right load
	CLR C
	SUBB A,R5        ;compare with R5
	JNC LESRL        ;jump if R5 less
	MOV MPEAR,R5     ;new max value store

;Auto Stop Check

LESRL:	JNB ASTEN,AS2    ;loop if autostop disable
	JNB TF1,AS2      ;loop if no timer1 overflow
	CLR TR1          ;timer1 stop
	CLR TF1          ;overflow clear
	INC ASC          ;inc program auto stop counter
	MOV A,NOWF
	CJNE A,#CODPL,AS5 ;jump if not play
	MOV A,ASC
	CJNE A,#ASDLP,AS1 ;jump if no overflow
	SJMP AS6
AS5:   MOV A,ASC
	CJNE A,#ASDLF,AS1 ;jump if no overflow

AS6:	MOV A,NOWF        ;do autostop
	CJNE A,#CODPL,AS7 ;jump if not play
	JNB LCONP,AS7     ;jump if repeat off
	MOV MISF,#CODRW
	SJMP AS2
AS7:	CJNE A,#CODRW,AS8 ;stop if not rewind
	MOV A,CLPBD
	CJNE A,#CODPL,AS8  ;stop if CLPBD<>PLAY
	MOV MISF,CLPBD   ;load play mode
	SJMP AS2
AS8:	MOV MISF,#CODST
	SJMP AS2

AS1:	MOV TH1,#0H      ;timer 1 load
	MOV TL1,#0H
	SETB TR1         ;timer1 start
AS2:	LJMP MAIN        ;loop

;---Subroutines Area---

;---Long Functions---

;Load Function

LOD:   MOV A,DELVAL     ;delay block
	JZ L1
	LCALL DEL50
	DEC DELVAL
	RET
L1:	MOV A,PROF       ;processing function check
	XRL A,#CODLO
	JZ L2
	MOV R2,#GRLOA    ;load symbol code
	LCALL GRAPH      ;display graphic
	SETB FAST        ;set fast main loop flag
	CLR UNLD         ;clear unload flag
	MOV PROF,#CODLO
	MOV CLPBD,#CODST
	MOV NOWF,#0H
	LCALL MVR        ;move rear
	SETB LP          ;load power on
	LCALL WRL
	MOV DELVAL,#4H
	JNB CSTIN,L3     ;cassette sensor check
	MOV MISF,#CODEJ  ;load EJECT code if no cassette
L3:	RET

L2:    LCALL MVD        ;move dovn
	MOV NOWF,#CODLO
	MOV R2,#GRSTP
	LCALL GRAPH
	SETB LEJEC       ;eject led on
	LCALL TTYP       ;tape type and leds on/off (uses LEDS)
	CLR FAST
	SETB CLDD
	JNB LAUTP,L4
	MOV MISF,#CODPL
L4:	RET

;Eject Function

EJT:	MOV A,DELVAL     ;delay block
	JZ E1
	LCALL DEL50
	DEC DELVAL
	RET

E1:	MOV A,PROF
	XRL A,#CODEJ
	JZ E2
	MOV R2,#GREJE
	LCALL GRAPH
	MOV MEML,#0FFH   ;memory clear
	MOV MEMH,#0FFH
	CLR LAUXF
	CLR LEJEC
	CLR LIEC1
	CLR LIEC2
	LCALL LEDS
	CLR GMUT
	LCALL ELC
	MOV PROF,#CODEJ
	MOV CLPBD,#CODST
	MOV NOWF,#0H
	MOV PART,#0H
	CLR ASTEN
	RET

E2:	MOV A,PART
	CJNE A,#0H,E3
	LCALL MVOM
	LCALL WRO0
	INC PART
	RET

E3:    CJNE A,#1H,E4
	LCALL MVOS
	INC PART
	RET

E4:	CJNE A,#2H,E5
	JB TAPS,ES
	MOV DELVAL,#8H
	SETB TAPS
ES:	INC PART
	RET

E5:	CJNE A,#3H,E6
	SETB FAST
	CLR ERROR
	LCALL MVU
	MOV DELVAL,#3H
	INC PART
	RET

E6:    LCALL MVF
	MOV NOWF,#CODEJ
	CLR FAST
	SETB UNLD
	SETB LP
	LCALL WRL
	MOV R2,#GRCLE
	LCALL GRAPH
	LCALL DEL50
	RET

;Stop Function

STP:   MOV A,DELVAL     ;delay block
	JZ S1
	LCALL DEL50
	DEC DELVAL
	RET

S1:    MOV A,PROF       ;processing function check
	XRL A,#CODST
	JZ S2
	MOV R2,#GRSTP    ;load symbol code
	LCALL GRAPH      ;display graphic
	MOV PROF,#CODST
	MOV CLPBD,#CODST
	MOV NOWF,#0H
	MOV PART,#0H
	LCALL MVD        ;move down
	SETB LEJEC       ;eject led on
	LCALL TTYP
	CLR GMUT
	LCALL ELC
	CLR FAST
	SETB CLDD
	CLR ASTEN
	RET

S2:    MOV A,PART
	CJNE A,#0H,S3
	LCALL MVOM
	LCALL WRO0
	INC PART
	RET

S3:	CJNE A,#1H,S4
	LCALL MVOS
	INC PART
	RET

S4:    JB TAPS,S5
	MOV DELVAL,#8H
	SETB TAPS
	RET

S5:	MOV NOWF,#CODST
	RET

PLY:   MOV A,DELVAL     ;delay block
	JZ PL1
	LCALL DEL50
	DEC DELVAL
	RET
PL1:   MOV A,PROF       ;processing function check
	XRL A,#CODPL
	JZ PL2
	MOV R2,#GRPLY    ;load symbol code
	LCALL GRAPH      ;display graphic
	MOV PROF,#CODPL
	MOV CLPBD,#CODPL
	MOV NOWF,#0H
	MOV PART,#0H
	LCALL MVD        ;move dovn
	SETB LEJEC       ;eject led on
	LCALL TTYP
	CLR GMUT
	LCALL ELC
	CLR FAST
	SETB CLDD
	CLR ASTEN
	RET

PL2:   MOV A,PART
	CJNE A,#0,PL3
	LCALL WRO0
	SETB DRIVEM
	LCALL WRO
	INC PART
	RET

PL3:	CJNE A,#1H,PL4
	JB TAPS,PLS
	MOV DELVAL,#8H
	SETB TAPS
PLS:   INC PART
	RET

PL4:	CJNE A,#2H,PL5
	SETB WINDM
	LCALL WRO
	LCALL DEL50
	CLR WINDM
	LCALL WRO
	LCALL MVIU
	INC PART
	RET

PL5:   CJNE A,#3H,PL6
	LCALL MVIP
	CLR TAPS
	LCALL ASE
	MOV DELVAL,#5H
	INC PART
	RET

PL6:   SETB GMUT
	LCALL ELC
	MOV NOWF,#CODPL
	RET

PSE:   MOV A,DELVAL     ;delay block
	JZ PA1
	LCALL DEL50
	DEC DELVAL
	RET

PA1:   MOV A,PROF       ;processing function check
	XRL A,#CODPA
	JZ PA2
	MOV R2,#GRPAU    ;load symbol code
	LCALL GRAPH      ;display graphic
	MOV PROF,#CODPA
	MOV CLPBD,#CODPA
	MOV NOWF,#0H
	MOV PART,#0H
	LCALL MVD        ;move dovn
	SETB LEJEC       ;eject led on
	LCALL TTYP
	CLR GMUT
	LCALL ELC
	CLR FAST
	SETB CLDD
	CLR ASTEN
	RET

PA2:   MOV A,PART
	CJNE A,#0H,PA3
	LCALL MVOM
	LCALL WRO0
	INC PART
	RET

PA3:   CJNE A,#1H,PA4
	JB TAPS,PAS
	MOV DELVAL,#8H
	SETB TAPS
PAS:	INC PART
	RET

PA4:	LCALL MVIU
	MOV NOWF,#CODPA
	RET

REW:	MOV A,DELVAL     ;delay block
	JZ R1
	LCALL DEL50
	DEC DELVAL
	RET
R1:    MOV A,PROF       ;processing function check
	XRL A,#CODRW
	JZ R2
	MOV A,NOWF
	CJNE A,#CODPL,SR1
	JNB LVIEW,SR1
	MOV MISF,#CODSR
	RET
SR1:	MOV R2,#GRREW    ;load symbol code
	LCALL GRAPH      ;display graphic
	MOV PROF,#CODRW
	MOV NOWF,#0H
	MOV PART,#0H
	LCALL MVD        ;move dovn
	SETB LEJEC       ;eject led on
	LCALL TTYP
	CLR GMUT
	LCALL ELC
	CLR FAST
	SETB CLDD
	CLR ASTEN
	RET

R2:	MOV A,PART
	CJNE A,#0H,R3
	LCALL MVOM
	LCALL WRO0
	INC PART
	RET

R3:    CJNE A,#1H,R4
	LCALL MVOS
	INC PART
	RET

R4:	CJNE A,#2H,R5
	JB TAPS,RS
	MOV DELVAL,#8H
	SETB TAPS
RS:	INC PART
	RET

R5:	CJNE A,#3H,R6
	SETB REWM
	LCALL WRO
	LCALL DEL25
	CLR REWM
	LCALL WRO
	MOV DELVAL,#2H
	INC PART
	RET

R6:    SETB REWM
	LCALL WRO
	CLR TAPS
	LCALL ASE
	MOV NOWF,#CODRW
	RET

FFD:	MOV A,DELVAL     ;delay block
	JZ F1
	LCALL DEL50
	DEC DELVAL
	RET
F1:    MOV A,PROF       ;processing function check
	XRL A,#CODFF
	JZ F2
	MOV A,NOWF
	CJNE A,#CODPL,SF1
	JNB LVIEW,SF1
	MOV MISF,#CODSF
	RET
SF1:	MOV R2,#GRFFD    ;load symbol code
	LCALL GRAPH      ;display graphic
	MOV PROF,#CODFF
	MOV NOWF,#0H
	MOV PART,#0H
	LCALL MVD        ;move down
	SETB LEJEC       ;eject led on
	LCALL TTYP
	CLR GMUT
	LCALL ELC
	CLR FAST
	SETB CLDD
	CLR ASTEN
	RET

F2:	MOV A,PART
	CJNE A,#0H,F3
	LCALL MVOM
	LCALL WRO0
	INC PART
	RET

F3:    CJNE A,#1H,F4
	LCALL MVOS
	INC PART
	RET

F4:	CJNE A,#2H,F5
	JB TAPS,FS
	MOV DELVAL,#8H
	SETB TAPS
FS:	INC PART
	RET

F5:	CJNE A,#3H,F6
	SETB WINDM
	LCALL WRO
	LCALL DEL50
	CLR WINDM
	LCALL WRO
	MOV DELVAL,#2H
	INC PART
	RET

F6:    SETB FFDM
	LCALL WRO
	CLR TAPS
	LCALL ASE
	MOV NOWF,#CODFF
	RET

SCHR:  MOV A,DELVAL     ;delay block
	JZ SCHR1
	LCALL DEL50
	DEC DELVAL
	RET

SCHR1: MOV A,PROF       ;processing function check
	XRL A,#CODSR
	JZ SCHR2
	MOV R2,#GRREW    ;load symbol code
	LCALL GRAPH      ;display graphic
	MOV PROF,#CODSR
	MOV CLPBD,#CODST
	MOV NOWF,#0H
	MOV PART,#0H
	CLR ASTEN
	CLR GMUT
	LCALL ELC
	RET

SCHR2:	MOV A,PART
	CJNE A,#0H,SCHR3
	LCALL MVOM
	LCALL WRO0
	SETB TAPS
	INC PART
	RET

SCHR3: CJNE A,#1H,SCHR4
	LCALL MVOH
	INC PART
	RET

SCHR4:	CJNE A,#2H,SCHR5
	SETB REWM
	LCALL WRO
	LCALL DEL25
	CLR REWM
	LCALL WRO
	MOV DELVAL,#2H
	INC PART
	RET

SCHR5: CJNE A,#3H,SCHR6
	SETB REWM
	LCALL WRO
	CLR TAPS
	LCALL ASE
	INC PART
	RET

SCHR6: CPL BLINK
	MOV R2,#GRCLE
	JB BLINK,SCHR7
	MOV R2,#GRREW
SCHR7:	LCALL GRAPH
	MOV DELVAL,#2H
	RET

SCHF:  MOV A,DELVAL     ;delay block
	JZ SCHF1
	LCALL DEL50
	DEC DELVAL
	RET

SCHF1: MOV A,PROF       ;processing function check
	XRL A,#CODSF
	JZ SCHF2
	MOV R2,#GRFFD    ;load symbol code
	LCALL GRAPH      ;display graphic
	MOV PROF,#CODSF
	MOV CLPBD,#CODST
	MOV NOWF,#0H
	MOV PART,#0H
	CLR ASTEN
	CLR GMUT
	LCALL ELC
	RET

SCHF2:	MOV A,PART
	CJNE A,#0H,SCHF3
	LCALL MVOM
	LCALL WRO0
	SETB TAPS
	INC PART
	RET

SCHF3: CJNE A,#1H,SCHF4
	LCALL MVOH
	INC PART
	RET

SCHF4:	CJNE A,#2H,SCHF5
	SETB WINDM
	LCALL WRO
	LCALL DEL50
	CLR WINDM
	LCALL WRO
	MOV DELVAL,#2H
	INC PART
	RET

SCHF5: CJNE A,#3H,SCHF6
	SETB FFDM
	LCALL WRO
	CLR TAPS
	LCALL ASE
	INC PART
	RET

SCHF6: CPL BLINK
	MOV R2,#GRCLE
	JB BLINK,SCHF7
	MOV R2,#GRFFD
SCHF7:	LCALL GRAPH
	MOV DELVAL,#2H
	RET

;APLD Fast Forward Function

APLDF:	RET

;APLD Rewind Function

APLDR:	RET

;Test Function

TEST:	RET

;---Short Functions---

;Counter Reset Function

CTRES: MOV A,MISF
	XRL A,#CODTE
	JZ CTR3         ;reset disable when test
	MOV A,APN
	JNZ CTR3        ;reset disable in APLD mode
	JNB RTCE,CTR1   ;jump if real time counter disable
	MOV RTL,#0H     ;real time counter reset
	MOV RTH,#0H
	MOV RTPC,#10H   ;real time program counter load
	LCALL CIND
	RET
CTR1:	JNB CTEN,CTR2   ;jump if counter display disable
	MOV CTL,#0H     ;counter reset
	MOV CTH,#0H
	MOV MEML,#0FFH  ;memory reset
	MOV MEMH,#0FFH
	LCALL CIND      ;indication
	CLR LAUXF
	LCALL LEDS
	RET
CTR2:  MOV MEML,#0FFH  ;memory reset
	MOV MEMH,#0FFH
	LCALL CIND      ;indication
	CLR LAUXF
	LCALL LEDS
CTR3:	RET

;Memory Function

MEM:   MOV MEML,CTL    ;store CT in MEM
	MOV MEMH,CTH
	LCALL CIND
	SETB LAUXF
	LCALL LEDS
	RET

;APLD Function

AP:    MOV A,APN
	JNZ AP1
	JB APM,APOFF
	CLR LVIEW
	SETB APM
	LCALL LEDS
AP1:   RET
APOFF:	CLR APM
	LCALL LEDS           ;AP led on/off
	RET

;Save Function

SAV:	RET

;Counter Function

CT:	CLR RTCE
	CLR MEME
	SETB CTEN
	LCALL LEDS
	LCALL CIND
	RET

;Timer Function

TM:	CLR MEME
	CLR CTEN
	SETB RTCE
	LCALL LEDS
	LCALL CIND
	RET

;IEC1 Function

SIEC1: CLR LIEC2
	SETB LIEC1
	LCALL LEDS
	CLR EIEC2
	CLR EIEC4
	LCALL ELC
	RET

;IEC2 Function

SIEC2:	SETB LIEC2
	CLR LIEC1
	LCALL LEDS
	SETB EIEC2
	CLR EIEC4
	LCALL ELC
	RET

;IEC4 Function

SIEC4: CLR LIEC2
	CLR LIEC1
	LCALL LEDS
	CLR EIEC2
	SETB EIEC4
	LCALL ELC
	RET

;NR OFF Function

NROFF: CLR LDOLB
	CLR LDBYC
	CLR LDBYB
	LCALL LEDS
	CLR EDB
	CLR EDC
	LCALL ELC
	RET

;Dolby-B on Function

SDB:   SETB LDOLB
	CLR LDBYC
	SETB LDBYB
	LCALL LEDS
	CLR EDC
	SETB EDB
	LCALL ELC
	RET

;Dolby-C on Function

SDC:   SETB LDOLB
	SETB LDBYC
	CLR LDBYB
	LCALL LEDS
	CLR EDB
	SETB EDC
	LCALL ELC
	RET

;MPX on/off Function

SMPX:	RET

;Mute on/off Function

SMU:   CPL MUC          ;MUTE on/off
	MOV C,MUC
	CPL C
	MOV LMUTE,C
	LCALL LEDS
	LCALL ELC
	RET

;Phones Line Function

SPL:	RET

;Phones Correction Function

SPC:	RET

;Show Memory Function

SHM:   CLR RTCE
	CLR CTEN
	SETB MEME
	LCALL LEDS
	LCALL CIND
	RET

;Alt Memory and Counter Function

ALT:	RET

;Record on Function

REC:	RET

;Test Function

MTST:	RET

;Sleep Function

SLEEP:	RET

;Display Mode Function

DISMD: MOV A,DISPM
	CJNE A,#3H,SLE1
	MOV DISPM,#0H
	SJMP SLE2
SLE1:	INC DISPM
SLE2:  LCALL SETDM
	LCALL LEDS
	LCALL CIND
	RET

;Repeat Function

REPEAT:CPL LCONP
	LCALL LEDS
	RET

;Auto Play Function

AUTPL: CPL LAUTP
	LCALL LEDS
	RET

;View Function

VIEW:  MOV A,APN
	JNZ VIE1
	JB LVIEW,VOFF
	CLR APM
	SETB LVIEW
	LCALL LEDS
VIE1:	RET
VOFF:	CLR LVIEW
	LCALL LEDS
	RET

;Timer/Counter/Show Memory Function

TMCT:  JBC RTCE,CT1
	JBC CTEN,ME
	CLR MEME
	SETB RTCE
	SJMP TMCT1
CT1:	SETB CTEN
	SJMP TMCT1
ME:	SETB MEME
TMCT1:	LCALL LEDS
	LCALL CIND
	RET

;---Special Functions---

;Set Display Mode

SETDM: MOV C,MUC
	CPL C
	MOV LMUTE,C

	MOV C,EDB
	MOV LDBYB,C
	ORL C,EDC
	MOV LDOLB,C
	MOV C,EDC
	MOV LDBYC,C

	MOV A,DISPM
	JNZ STDM1
	SETB LSCAL       ;if DISPM = 0
	SETB LLFDB
	SETB LRTDB
	SETB LLEFT
	SETB LRIGT
	RET
STDM1: CLR LSCAL        ;if DISPM > 0
	CLR LLFDB
	CLR LRTDB
	CLR LLMIN
	CLR LRMIN
	CLR LLEFT
	CLR LRIGT
	MOV R0,#PEAKL
	MOV A,#0FFH
	MOVX @R0,A
	MOV R0,#PEAKR
	MOVX @R0,A
	MOV R0,#LDI1
	MOVX @R0,A
	MOV R0,#LDI2
	MOVX @R0,A
	RET

;Electric Signals Set

ELC:	MOV C,MUC
	ANL C,GMUT
	ANL C,/RECA
	MOV MUP,C
	MOV C,MUC
	ANL C,GMUT
	ANL C,RECA
	MOV MUR,C
	MOV C,EDB
	ORL C,EDC
	CPL C
	MOV EDOFF,C
	MOV R0,#MODE1
	MOV A,EL1
	MOVX @R0,A
	MOV R0,#MODE2
	MOV A,EL2
	MOVX @R0,A
	RET

;KKD Init

KKDIN:	MOV R0,#KD1C     ;KD1 control address load
	MOV A,#08H       ;mode 16 symb. left enter/counter
	MOVX @R0,A       ;mode init
	MOV A,#34H       ;100 KHz
	MOVX @R0,A       ;devider init
	MOV A,#90H       ;display memory write
	MOVX @R0,A       ;init
	MOV R0,#KD1D
	CLR A
	MOV R1,#10H
K1CLE:	MOVX @R0,A       ;clear display memory
	DJNZ R1,K1CLE

	MOV R0,#KD2C     ;KD2 init
	MOV A,#08H
	MOVX @R0,A
	MOV A,#34H
	MOVX @R0,A
	MOV A,#90H
	MOVX @R0,A
	MOV R0,#KD2D
	CLR A
	MOV R1,#10H
K2CLE:	MOVX @R0,A       ;clear display memory
	DJNZ R1,K2CLE
	RET

MVOM:  JB PLAYS,MVOM3
	SETB MVOUT
	LCALL WRO
MVOM1:	LCALL RDO
	JNB PAUSS,MVOM2
	JB OMDOV,MVOM1
	LJMP ERROP
MVOM2:	CLR WINDM
	CLR RTCG
	LCALL WRO
MVOM4:	LCALL RDO
	JNB MIDS,MVOM5
	JB OMDOV,MVOM4
	LJMP ERROP
MVOM5:	CLR MVOUT
	LCALL WRO
MVOM3: RET

MVOS:	JNB STOPS,MVOS1
	SETB MVOUT
	LCALL WRO
MVOS2:	LCALL RDO
	JNB STOPS,MVOS1
	JB OMDOV,MVOS2
	LJMP ERROP
MVOS1:	LCALL WRO0
	RET

MVOH:	JNB SEARS,MVOH1
	SETB MVOUT
	LCALL WRO
MVOH2:	LCALL RDO
	JNB SEARS,MVOH1
	JB OMDOV,MVOH2
	LJMP ERROP
MVOH1:	LCALL WRO0
	RET

MVIP:  SETB MVIN
	LCALL WRO
MVIP1:	LCALL RDO
	JNB WINDS,MVIP2
	JB OMDOV,MVIP1
	LJMP ERROP
MVIP2: SETB RTCG
	SETB FFDM
	LCALL WRO
	MOV R2,#7H
	LCALL DEL05
	CLR FFDM
	SETB WINDM
	LCALL WRO
MVIP3:	LCALL RDO
	JNB PLAYS,MVIP4
	JB OMDOV,MVIP3
	LJMP ERROP
MVIP4:	CLR MVIN
	LCALL WRO
	RET

MVIU:	SETB MVIN
	LCALL WRO
MVIU1:	LCALL RDO
	JNB PAUSS,MVIU2
	JB OMDOV,MVIU1
	LJMP ERROP
MVIU2:	CLR MVIN
	LCALL WRO
	RET

ERR:   JNB ERROR,ERR1
	LCALL WRL0
	MOV R2,#GRCLE
	LCALL GRAPH
	LCALL ERRB
	CLR FAST
	MOV MISF,#CODST
	MOV NOWF,#CODST
	MOV PROF,#CODST
	MOV SP,#STACK
	LJMP MAIN

ERR1:	SETB ERROR
	MOV R5,MLDWR
	CPL UNLDM
	CPL LOADM
	MOV R4,MLDWR
	CLR UNLDM
	CLR LOADM
	LCALL WRL
	LCALL DEL50
	MOV MLDWR,R4
	LCALL WRL
	LCALL DE100
	MOV MLDWR,R5
	LCALL WRL
	LCALL DE100
	RET

ERRB:	MOV R0,#5H
ERRB1:	SETB T1
	CLR T1
	LCALL DE100
	DJNZ R0,ERRB1
	RET

ERRBE:	MOV R0,#5H
ERRE1:	SETB T1
	CLR T1
	LCALL DE100
	LCALL DE100
	DJNZ R0,ERRE1
	RET

;Move Up

MVU:	SETB LP
	CLR ERROR
	LCALL WRL
	LCALL DE100
	LCALL RDL
	JB UP,UP2
	SETB EM2
	SETB EM3
	SETB LOADM
	LCALL WRL
	LCALL DEL25
	CLR LOADM
	SETB UNLDM
	LCALL WRL
	LCALL DE100
UP1:	LCALL RDL
	JB UP,UP2
	JB LMDOV,UP1
	LCALL ERR
	SJMP UP1
UP2:	LCALL WRL0
	RET

;Move Down

MVD:	SETB LP
	CLR ERROR
	LCALL WRL
	LCALL DE100
	LCALL RDL
	JB DOWN,DN2
	SETB EM2
	SETB EM3
	SETB UNLDM
	LCALL WRL
	LCALL DEL50
	CLR UNLDM
	SETB LOADM
	LCALL WRL
	LCALL DE100
DN1:	LCALL RDL
	JB DOWN,DN3
	JB LMDOV,DN1
	LCALL ERR
	SJMP DN1
DN3:	CLR EM3
	LCALL WRL
	LCALL DEL50
	CLR LOADM
	LCALL WRL
	LCALL DE100
DN2:	LCALL WRL0
	RET

;Move Rear

MVR:	SETB LP
	CLR ERROR
	LCALL WRL
	LCALL DE100
	LCALL RDL
	JB REAR,RE2
	SETB EM1
	SETB LOADM
	LCALL WRL
	LCALL DE100
RE1:	LCALL RDL
	JB REAR,RE2
	JB LMDOV,RE1
	LCALL ERR
	SJMP RE1
RE2:	LCALL WRL0
	RET

;Move Front

MVF:	SETB LP
	CLR ERROR
	LCALL WRL
	LCALL DE100
	LCALL RDL
	JB FRONT,FR2
	SETB EM1
	SETB LOADM
	LCALL WRL
	LCALL DEL50
	CLR LOADM
	SETB UNLDM
	LCALL WRL
	LCALL DE100
FR1:	LCALL RDL
	JB FRONT,FR3
	JB LMDOV,FR1
	LCALL ERR
	SJMP FR1
FR3:	CLR UNLDM
	LCALL WRL
	LCALL DE100
FR2:	LCALL WRL0
	RET

NORMO:	LCALL RDO
	JNB STOPS,NR1
	SETB MVOUT
	LCALL WRO
NR2:	LCALL RDO
	JNB STOPS,NR1
	JB OMDOV,NR2
	LJMP ERROP
NR1:	LCALL WRO0
	SETB TAPS
	RET

ERROP: LCALL WRO0
	LCALL ERRBE
	SETB MVOUT
	LCALL WRO
NR3:	LCALL RDO
	JNB STOPS,NR4
	JB OMDOV,NR3
NR4:   LCALL WRO0
	MOV MISF,#CODST
	MOV NOWF,#CODST
	MOV PROF,#CODST
	MOV SP,#STACK
	LJMP MAIN

NORML:	SETB LP
	LCALL WRL
	LCALL DE100
	LCALL RDL
	JNB DOWN,NL2
	LJMP NL9
NL2:	JB UP,NL1
	CLR ERROR
	SETB EM2
	SETB EM3
	SETB LOADM
	LCALL WRL
	LCALL DEL25
	CLR LOADM
	SETB UNLDM
	LCALL WRL
	LCALL DE100
NL3:	LCALL RDL
	JB UP,NL4
	JB LMDOV,NL3
	LCALL WRL0
	LCALL DE100
	LCALL MVD
	LCALL DE100
	LCALL MVR
	LCALL DE100
	LCALL MVU
	LCALL DE100
NL4:	LCALL WRL0
NL1:   SETB LP
	CLR ERROR
	LCALL WRL
	LCALL DE100
	LCALL RDL
	JB FRONT,NL5
	SETB EM1
	SETB LOADM
	LCALL WRL
	LCALL DEL50
	CLR LOADM
	SETB UNLDM
	LCALL WRL
	LCALL DE100
NL6:	LCALL RDL
	JB FRONT,NL7
	JB LMDOV,NL6
	LCALL WRL0
	LCALL DE100
	LCALL MVR
	LCALL DE100
	LCALL MVF
NL7:	CLR UNLDM
	LCALL WRL
	LCALL DE100
NL5:	LCALL WRL0
	CLR CLDD
	SETB UNLD
	SETB LP
	LCALL WRL
	LCALL DE100
	RET
NL9:   CLR UNLD
	SETB CLDD
	SETB LEJEC
	LCALL TTYP
	MOV R2,#GRSTP
	LCALL GRAPH
	RET

DEL25:	MOV R2,#50       ;delay 25mS, uses R2, R3
	LCALL DEL05
	RET

DEL50:	MOV R2,#100      ;delay 50mS, uses R2, R3
	LCALL DEL05
	RET

DE100: MOV R2,#200      ;delay 100mS, uses R2, R3
	LCALL DEL05
	RET

DEL05:	MOV R3,#250      ;delay R2x0.5mS, uses R2,R3
	DJNZ R3,$
	DJNZ R2,DEL05
	RET

;Write To Load Register

WRL:	MOV R0,#LOAD
	MOV A,MLDWR
	MOVX @R0,A
	RET

;Write Load Register With Zero

WRL0:	MOV R0,#LOAD
	CLR A
	MOV MLDWR,A
	MOVX @R0,A
	RET

;Read From Load Register

RDL:	MOV R0,#LOAD
	MOVX A,@R0
	MOV MLDRD,A
	RET

;Write To Operation Register

WRO:	MOV R0,#OPER
	MOV A,MOPWR
	MOVX @R0,A
	RET

;Write Operate Register With Zero

WRO0:	MOV R0,#OPER
	CLR A
	MOV MOPWR,A
	MOVX @R0,A
	RET

;Read From Operation Register

RDO:	MOV R0,#OPER
	MOVX A,@R0
	MOV MOPRD,A
	RET

;Autostop Enable Function

ASE:	CLR TR1          ;timer1 stop
	CLR TF1          ;overflow clear
	MOV TH1,#0H      ;timer1 load
	MOV TL1,#0H
	MOV ASC,#0H      ;program counter clear
	SETB TR1         ;timer1 start
	SETB ASTEN       ;autostop enable
	RET

;Tape Type Leds On/Off

TTYP:	JNB IEC2,TTPY1
	LCALL SIEC2
	RET
TTPY1: LCALL SIEC1
	RET

;ADC Subroutine

ADC:	MOV R0,#DACM     ;A/D - convertion for left channel
	MOV R1,#08H      ;R5 - output 8-bit code
	MOV R2,#01H
	MOV R5,#00H
ADC1:	MOV A,R2
	RR A
	MOV R2,A
	ORL A,R5
	MOVX @R0,A
	NOP
	NOP
	NOP
	NOP
	NOP
	JB COM,ADC2
	MOV R5,A
ADC2:	DJNZ R1,ADC1
	RET

;Level Indicator Encoder

LC:	MOV DPTR,#LTAB   ;R5-input 8-bit code
	CLR A            ;R0,R1,R2,R3-output
	MOV R0,A
	MOV R1,A
	MOV R2,A
	MOV R3,A
	MOV R4,A         ;counter

LC1:	MOV A,R4
	MOVC A,@A+DPTR
	MOV R6,A
	MOV A,R5
	CLR C
	SUBB A,R6
	MOV A,R0
	RRC A
	MOV R0,A
	INC R4
	MOV A,R4
	CJNE A,#6H,LC1

	MOV A,R0
	RR A
	RR A
	MOV R0,A

LC2:	MOV A,R4
	MOVC A,@A+DPTR
	MOV R6,A
	MOV A,R5
	CLR C
	SUBB A,R6
	MOV A,R1
	RRC A
	MOV R1,A
	INC R4
	MOV A,R4
	CJNE A,#0AH,LC2

	MOV A,R1
	SWAP A
	MOV C,LCR
	MOV ACC5,C
	MOV R1,A

LC3:	MOV A,R4
	MOVC A,@A+DPTR
	MOV R6,A
	MOV A,R5
	CLR C
	SUBB A,R6
	MOV A,R2
	RRC A
	MOV R2,A
	INC R4
	MOV A,R4
	CJNE A,#10H,LC3

	MOV A,R2
	RR A
	RR A
	MOV R2,A

LC4:	MOV A,R4
	MOVC A,@A+DPTR
	MOV R6,A
	MOV A,R5
	CLR C
	SUBB A,R6
	MOV A,R3
	RRC A
	MOV R3,A
	INC R4
	MOV A,R4
	CJNE A,#14H,LC4

	MOV A,R3
	SWAP A
	ORL A,#10H
	MOV C,LCR
	MOV ACC5,C
	MOV R3,A

	RET

;HEX to Decimal Converter

HEX2D: CJNE A,#7FH,CONVE
	MOV A,#0FFH
	RET
CONVE:	MOV B,#0AH       ;convert hex to 2/10 (format CH10)
	DIV AB
	SWAP A
	JNZ CONV1
	MOV A,#0F0H
CONV1:	ADD A,B
	RET

;Counter Indicate

CIND:  MOV A,APN
	JZ CIND0
	MOV R3,#0FFH     ;load blank code for high indicator
	ANL A,#0F0H
	JNZ CIND3
	MOV A,APN
	ORL A,#0F0H      ;blanc cone for APN<10
	SJMP CIND2
CIND3: MOV R2,APN
	SJMP CIND2

CIND0: JNB CTEN,CIND1
	MOV R2,CTL       ;load counter value
	MOV R3,CTH
	SJMP CIND2

CIND1: JNB RTCE,CIND4
	MOV R2,RTL       ;load real time counter value
	MOV R3,RTH
	SJMP CIND2

CIND4: MOV R2,MEML      ;load memory value
	MOV R3,MEMH
CIND2: LCALL HEX        ;indicate
	RET

;Load LEDs Registers From Copy

LEDS:  MOV A,DISPM
	JZ LEDON
	DEC A
	JZ LEDON
	CLR A
	MOV R0,#LEDS1
	MOVX @R0,A
	MOV R0,#LEDS2
	MOVX @R0,A
	MOV R0,#LEDS3
	MOVX @R0,A
	MOV R0,#LEDS4
	MOVX @R0,A
	RET
LEDON:	MOV R0,#LEDS1
	MOV A,MLED1
	MOVX @R0,A
	MOV R0,#LEDS2
	MOV A,MLED2
	MOVX @R0,A
	MOV R0,#LEDS3
	MOV A,MLED3
	MOVX @R0,A
	MOV R0,#LEDS4
	MOV A,MLED4
	MOVX @R0,A
	RET

;Write HEX-Value To The Matrix LEDS From R3,R2

HEX:   MOV A,DISPM
	CJNE A,#3H,HEXON
	LJMP MCLEAR
HEXON:	MOV R0,#KD2C     ;KD2 control address
	MOV A,#9BH       ;1-st digit address
	MOVX @R0,A       ;write control word
	MOV R1,#KD2D     ;KD2 data address
	MOV A,R3         ;Hi byte to ACC
	SWAP A
	LCALL HEX1       ;display 1-st digit

	MOV R0,#KD1C     ;KD1 control address
	MOV A,#90H       ;2-nd digit address
	MOVX @R0,A       ;write control word
	MOV R1,#KD1D     ;KD1 data address
	MOV A,R3         ;Hi byte to ACC
	LCALL HEX1       ;display 2-nd digit

	MOV A,R2         ;Lo byte to ACC
	SWAP A
	LCALL HEX1       ;display 3-rd digit

	MOV A,#9BH       ;4-th digit address (point skip)
	MOVX @R0,A       ;write control word
	MOV A,R2         ;Lo byte to ACC
	LCALL HEX1       ;display 4-th digit
	RET

HEX1:	ANL A,#0FH       ;symb. code select
	MOV B,#5H
	MUL AB           ;symb. code x 5
	MOV B,A          ;shift store
	MOV DPTR,#SGEN   ;symb. table address
	MOV R4,#5H       ;bytes per symbol counter
HEX11: MOV A,B          ;shift to ACC
	MOVC A,@A+DPTR   ;read byte from table
	MOVX @R1,A       ;write byte to KD
	INC DPTR         ;address+1
	DJNZ R4,HEX11    ;loop
	RET

MCLEAR:MOV R0,#KD2C
	MOV A,#9BH       ;display memory write
	MOVX @R0,A       ;init
	MOV R0,#KD2D
	CLR A
	MOV R1,#5H
CLE1:	MOVX @R0,A       ;clear display memory
	DJNZ R1,CLE1

	MOV R0,#KD1C
	MOV A,#90H       ;display memory write
	MOVX @R0,A       ;init
	MOV R0,#KD1D
	CLR A
	MOV R1,#10H
CLE2:	MOVX @R0,A       ;clear display memory
	DJNZ R1,CLE2
	RET

;Write Graphics Symbols To The Matrix LEDS From R2

GRAPH: MOV R0,#KD2C     ;KD2 control address
	MOV A,#90H       ;1-sd position address
	MOVX @R0,A       ;write control word
	MOV R1,#KD2D     ;KD2 data address
	MOV A,R2
	SWAP A
	LCALL GR1        ;display 1-st symbol
	MOV A,R2
	LCALL GR1        ;display 2-nd symbol
	RET

GR1:	ANL A,#0FH       ;symb. code select
	MOV B,#5H
	MUL AB           ;symb. code x 5
	MOV B,A          ;shift store
	MOV DPTR,#GGEN   ;symb. table address
	MOV R4,#5H       ;bytes per symbol counter
GR11:  MOV A,B          ;shift to ACC
	MOVC A,@A+DPTR   ;read byte from table
	MOVX @R1,A       ;write byte to KD
	INC DPTR         ;address+1
	DJNZ R4,HEX11    ;loop
	RET

;log level table

LTAB   .DB 000H ;-oo dB
	.DB 003H ;-30 dB
	.DB 007H ;-25 dB
	.DB 00AH ;-21 dB
	.DB 00EH ;-18 dB
	.DB 014H ;-15 dB
	.DB 01CH ;-12 dB
	.DB 024H ;-10 dB
	.DB 02DH ;- 8 dB
	.DB 039H ;- 6 dB
	.DB 048H ;- 4 dB
	.DB 050H ;- 3 dB
	.DB 05AH ;- 2 dB
	.DB 065H ;- 1 dB
	.DB 072H ;  0 dB
	.DB 080H ;+ 1 dB
	.DB 090H ;+ 2 dB
	.DB 0A1H ;+ 3 dB
	.DB 0CBH ;+ 5 dB
	.DB 0FFH ;+ 7 dB

LOGTAB	.DB 0FFH,0A3H,09DH,09AH,097H,095H,094H,092H
	.DB 091H,090H,08FH,08EH,08EH,08DH,08CH,08CH
	.DB 08BH,08BH,08AH,08AH,089H,089H,088H,088H
	.DB 088H,087H,087H,086H,086H,086H,086H,085H
	.DB 085H,085H,084H,084H,084H,084H,084H,083H
	.DB 083H,083H,083H,082H,082H,082H,082H,082H
	.DB 081H,081H,081H,081H,081H,081H,000H,000H
	.DB 000H,000H,000H,000H,000H,001H,001H,001H
	.DB 001H,001H,001H,001H,002H,002H,002H,002H
	.DB 002H,002H,002H,002H,002H,003H,003H,003H
	.DB 003H,003H,003H,003H,003H,003H,004H,004H
	.DB 004H,004H,004H,004H,004H,004H,004H,004H
	.DB 005H,005H,005H,005H,005H,005H,005H,005H
	.DB 005H,005H,005H,005H,006H,006H,006H,006H
	.DB 006H,006H,006H,006H,006H,006H,006H,006H
	.DB 006H,007H,007H,007H,007H,007H,007H,007H
	.DB 007H,007H,007H,007H,007H,007H,007H,007H
	.DB 008H,008H,008H,008H,008H,008H,008H,008H
	.DB 008H,008H,008H,008H,008H,008H,008H,008H
	.DB 009H,009H,009H,009H,009H,009H,009H,009H
	.DB 009H,009H,009H,009H,009H,009H,009H,009H
	.DB 009H,009H,009H,00AH,00AH,00AH,00AH,00AH
	.DB 00AH,00AH,00AH,00AH,00AH,00AH,00AH,00AH
	.DB 00AH,00AH,00AH,00AH,00AH,00AH,00AH,00BH
	.DB 00BH,00BH,00BH,00BH,00BH,00BH,00BH,00BH
	.DB 00BH,00BH,00BH,00BH,00BH,00BH,00BH,00BH
	.DB 00BH,00BH,00BH,00BH,00BH,00BH,00BH,00CH
	.DB 00CH,00CH,00CH,00CH,00CH,00CH,00CH,00CH
	.DB 00CH,00CH,00CH,00CH,00CH,00CH,00CH,00CH
	.DB 00CH,00CH,00CH,00CH,00CH,00CH,00CH,00CH
	.DB 00CH,00DH,00DH,00DH,00DH,00DH,00DH,00DH
	.DB 00DH,00DH,00DH,00DH,00DH,00DH,00DH,00DH

SGEN	.DB 3EH,41H,41H,41H,3EH ;0		00H
	.DB 00H,00H,42H,7FH,40H ;1  	01H
	.DB 62H,51H,49H,49H,46H ;2 		02H
	.DB 21H,41H,49H,4DH,33H ;3 		03H
	.DB 18H,14H,12H,7FH,10H ;4  	04H
	.DB 27H,45H,45H,45H,39H ;5  	05H
	.DB 3CH,4AH,49H,49H,31H ;6  	06H
	.DB 01H,71H,09H,05H,03H ;7  	07H
	.DB 36H,49H,49H,49H,36H ;8  	08H
	.DB 46H,49H,49H,29H,1EH ;9  	09H
	.DB 7CH,0AH,09H,0AH,7CH ;A  	0AH
	.DB 7FH,49H,49H,49H,36H ;B  	0BH
	.DB 3EH,41H,41H,41H,22H ;C  	0CH
	.DB 7FH,41H,41H,41H,3EH ;D  	0DH
	.DB 7FH,49H,49H,49H,41H ;E  	0EH
	.DB 7FH,09H,09H,09H,01H ;F  	0FH

GGEN	.DB 00H,00H,00H,00H,00H ;space     00H
	.DB 08H,14H,22H,7FH,00H ;<  	01H
	.DB 7FH,22H,14H,08H,00H ;>  	02H
	.DB 7FH,41H,41H,7FH,00H ;pause     03H
	.DB 3EH,22H,22H,22H,3EH ;stop      04H
	.DB 1CH,22H,22H,22H,1CH ;record    05H
	.DB 0CH,14H,24H,14H,0CH ;load      06H
	.DB 30H,28H,24H,28H,30H ;eject     07H

	.END
